"""Add character table

Revision ID: 9a87c5ed9d12
Revises: b57a40c2b63d
Create Date: 2023-10-18 00:00:00.000000

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = '9a87c5ed9d12'
down_revision = 'b57a40c2b63d'
branch_labels = None
depends_on = None


def upgrade() -> None:
    # Create character table
    op.create_table(
        'character',
        sa.Column('id', sa.Integer(), nullable=False),
        sa.Column('name', sa.String(255), nullable=False),
        sa.Column('role', sa.String(50), nullable=True),
        sa.Column('description', sa.Text(), nullable=True),
        sa.Column('voice_actor', sa.String(255), nullable=True),
        sa.Column('image_url', sa.String(255), nullable=True),
        sa.Column('anime_id', sa.Integer(), nullable=False),
        sa.Column('age', sa.String(50), nullable=True),
        sa.Column('gender', sa.String(50), nullable=True),
        sa.Column('birth_date', sa.Date(), nullable=True),
        sa.Column('height', sa.String(50), nullable=True),
        sa.Column('weight', sa.String(50), nullable=True),
        sa.Column('blood_type', sa.String(10), nullable=True),
        sa.Column('popularity_rank', sa.Integer(), nullable=True),
        sa.ForeignKeyConstraint(['anime_id'], ['anime.id'], ondelete='CASCADE'),
        sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_character_id'), 'character', ['id'], unique=False)
    op.create_index(op.f('ix_character_name'), 'character', ['name'], unique=False)


def downgrade() -> None:
    op.drop_index(op.f('ix_character_name'), table_name='character')
    op.drop_index(op.f('ix_character_id'), table_name='character')
    op.drop_table('character')